// this code is programed auto by dialog editor.
#include <sstream>
#include <cstdio>
#include "_APPNAME_Application.h"
#include "_APPNAME_DialogMaker.h"

#define debugs  { cout << __FILE__ << ':' << __LINE__ << ':' << __FUNCTION__ << endl; }
#define debugs2(out)  { cout << __FILE__ << ':' << __LINE__ << ':' << __FUNCTION__ << ' ' << out << endl; }

_APPNAME_Application::_APPNAME_Application(PGDialogMaker& dm) : PGApplication(dm)
{
    debugs;
}

//-----------------------------------------------------------------------------
int _APPNAME_Application::OnInit()
{
    debugs;
    // アプリケーションで必要な初期化を行って下さい

    // サンプル（認証で乱数を使用する）
    srand(time(NULL));

	// 参考
	// 共有タイプのダイアログで端末の接続が無くても予めリソースを用意しておく必要がある場合
	//app->CreateDialog("Shared");


	// セッションタイムアウトをチェックする間隔（10秒）
    SetApplicationTimerInterval(10*1000,100);
    return 0;
}

bool _APPNAME_Application::OnAuth( const SGString &name, const SGString &pass, PGClientSocket *pgsock )
{
    debugs;
    // edit here
    // ここですべきこと：認証処理
    // HELLO電文にあるログインネーム、パスワードにより認証をおこなう
    // 認証に成功したら、pgsock内のセッションIDをセットする
    // 認証に失敗したら、セッションIDをクリアする
    
    // このサンプルでは認証にguest/guestを使用する
    // セッションIDはランダムな値を設定する（すべての接続は別個のセッションと扱う）
    if( name=="guest" && pass=="guest" ){

    	// タイマーを停止する(タイムアウト用)
    	SetApplicationSingleTimerInterval(0,pgsock->GetId());

        stringstream ss;
        ss << rand() << '-' << time(NULL);
        SGString sessionid = ss.str();
        
        cout << "SESSIONID:" << sessionid << endl;
        pgsock->mSessionId = sessionid;
        pgsock->mAuth = true;
        
	    // セッションリストを確認し、存在しなければ作る
		CreateSession(sessionid,TIMEOUT_SESSION);
        return true;
    }
    
    pgsock->mSessionId = "";
    return true;
}

bool _APPNAME_Application::OnAuthCheck( const SGString &sessionid, PGClientSocket *pgsock )
{
    debugs;
    // edit here
    // ここですべきこと：認証処理
    // HELLO電文にあるセッションIDより認証をおこなう
    // 認証に成功したら、pgsock内のセッションIDをセットする
    // 認証に失敗したら、セッションIDをクリアする
    
    // セッションリストを確認し、存在すれば認証を認める
    if( mSessionList.Has(sessionid)>0 ){

    	// タイマーを停止する(タイムアウト用)
    	SetApplicationSingleTimerInterval(0,pgsock->GetId());

        pgsock->mSessionId = sessionid;
        pgsock->mAuth = true;
        return true;
    }
    
    pgsock->mSessionId = "";
    return false;
}

void _APPNAME_Application::ApplicationTimer(TimeVal tv,unsigned int id)
{
   // edit here
    // ここですべきこと：認証処理
    // 一定時間おきに起動されるので、
    // 各ダイアログのタイマー関数を起動するなどの
    // タイマー処理をおこなう
//    debugs2(id);

	if( id == 100 ){
	    // 全体のセッションのタイムアウト確認をおこなう
	    SessionList()->CheckExpire();
	    return;
	}

	PGClientSocket* socket = NULL;
	int message = GetSocket(id, &socket);
	if( socket != NULL ){
		switch( message ){
		case 0: // コネクションから認証までのタイムアウト時間(秒) 10
			printf("コネクションタイムアウト\n");
			socket->Close();
			break;
		case 1: // 最後の受信からKEEPALIVE送信までの時間(秒) 10
			socket->SendData("{'Command':'KEEPALIVE'}");
			SetApplicationSingleTimerInterval(0,socket->GetId()+2);
			SetApplicationSingleTimerInterval(TIMEOUT_CONNECTION*1000,socket->GetId()+2);
			break;
		case 2: // KEEPALIVE応答タイムアウト
			printf("KEEPALIVE応答タイムアウト\n");
			socket->Close();
			break;
		}
	}
}
